import arrayWithHoles from '@babel/runtime/helpers/esm/arrayWithHoles';
import iterableToArrayLimit from '@babel/runtime/helpers/esm/iterableToArrayLimit';
import unsupportedIterableToArray from '@babel/runtime/helpers/esm/unsupportedIterableToArray';
import nonIterableRest from '@babel/runtime/helpers/esm/nonIterableRest';
import React, { useState } from 'react';
import styled, { css } from 'styled-components';

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
}

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

var mediaQuery = function mediaQuery(maxWidth) {
  return "\n  @media (max-width: ".concat(maxWidth, "px)\n");
};

var palette = {
  base: {
    white: '#ffffff',
    gray100: '#f7f7f7',
    gray150: '#f2f2f2',
    gray200: '#efefef',
    gray250: '#e8e8e8',
    gray300: '#e0e0e0',
    gray350: '#c7c7c7',
    gray400: '#aeaeae',
    gray500: '#959595',
    gray600: '#7c7c7c',
    gray700: '#646464',
    gray800: '#4a4a4a',
    gray900: '#232323',
    black: '#181818'
  },
  point: {
    red_getcha: '#ef3333',
    yellow_reward: '#ffd516',
    yellow_owner: '#e59f00',
    mint_realowner: '#29c5bb',
    blue_getcha: '#1d8ae4',
    green_getcha: '#38c52f'
  },
  yellow: {
    yellow_10: '#fcf5b3',
    yellow_20: '#fff385',
    yellow_30: '#ffe817',
    yellow_40_review: '#f0a22e'
  },
  mint: {
    mint_10: '#99e5d3',
    mint_20: '#0a8f61',
    mint_30: '#3aac87',
    mint_40: '#0a8f6'
  },
  blue: {
    blue_10: '#9cd6fa',
    blue_20: '#5db0ef',
    blue_30: '#1d8ae4',
    blue_40: '#265cd5'
  },
  red: {
    red_10: '#ffafaa',
    red_20: '#ff7970',
    red_30: '#e5403a',
    red_40: '#bc1b17'
  }
};

function _templateObject() {
  var data = _taggedTemplateLiteral([""]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var SVGIcon = styled.svg.attrs({
  version: '1.1',
  xmlns: 'http://www.w3.org/2000/svg',
  xmlnsXlink: 'http://www.w3.org/1999/xlink'
})(_templateObject());

function _templateObject$1() {
  var data = _taggedTemplateLiteral([""]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var SVG = styled(SVGIcon)(_templateObject$1());

var CabinetSVG = function CabinetSVG(_ref) {
  var _ref$darkMode = _ref.darkMode,
      darkMode = _ref$darkMode === void 0 ? false : _ref$darkMode;
  return /*#__PURE__*/React.createElement(SVG, {
    viewBox: "0 0 28 28",
    width: 28,
    height: 28
  }, /*#__PURE__*/React.createElement("path", {
    d: "M23.278 13.4426L21.072 6.23425C21.015 6.04764 20.8424 5.92 20.6472 5.92H7.48061C7.28547 5.92 7.11282 6.04764 7.05579 6.23425L4.84985 13.4426C4.81687 13.5512 4.7998 13.6645 4.7998 13.7781V22.29C4.7998 22.6814 5.11716 22.9984 5.50822 22.9984H22.6192C23.0107 22.9984 23.3276 22.6811 23.3276 22.29V13.7781C23.328 13.6645 23.3109 13.5512 23.278 13.4426ZM20.6678 13.6067H16.5228C16.2761 13.6067 16.0596 13.7754 16.0037 14.016C15.7996 14.899 15.0086 15.5569 14.0639 15.5569C13.1192 15.5569 12.3282 14.899 12.1241 14.016C12.0686 13.7754 11.8518 13.6067 11.605 13.6067H7.46005C7.20826 13.6067 7.02747 13.3638 7.10002 13.1225L8.66273 7.92731C8.71937 7.73953 8.89201 7.61112 9.08793 7.61112H19.0395C19.2354 7.61112 19.4085 7.73953 19.4647 7.92731L21.0274 13.1225C21.1003 13.3638 20.9199 13.6067 20.6678 13.6067Z",
    fill: darkMode ? palette.base.white : palette.base.black
  }), /*#__PURE__*/React.createElement("path", {
    d: "M16.6372 9.56682H11.4913C10.9159 9.56682 10.4492 10.0335 10.4492 10.6089C10.4492 11.1842 10.9155 11.6509 11.4913 11.6509H16.6372C17.2125 11.6509 17.6793 11.1842 17.6793 10.6089C17.6793 10.0331 17.2125 9.56682 16.6372 9.56682Z",
    fill: darkMode ? palette.base.white : palette.base.black
  }));
};

function _templateObject$2() {
  var data = _taggedTemplateLiteral([""]);

  _templateObject$2 = function _templateObject() {
    return data;
  };

  return data;
}
var SVG$1 = styled(SVGIcon)(_templateObject$2());

var SearchSVG = function SearchSVG(_ref) {
  var _ref$darkMode = _ref.darkMode,
      darkMode = _ref$darkMode === void 0 ? false : _ref$darkMode;
  return /*#__PURE__*/React.createElement(SVG$1, {
    viewBox: "0 0 24 24",
    width: "24",
    height: "24",
    fill: "none"
  }, /*#__PURE__*/React.createElement("circle", {
    cx: "11",
    cy: "11",
    r: "5",
    stroke: darkMode ? palette.base.white : palette.base.black,
    strokeWidth: "2"
  }), /*#__PURE__*/React.createElement("path", {
    d: "M15 15L19.5 19.5",
    stroke: darkMode ? palette.base.white : palette.base.black,
    strokeWidth: "2"
  }));
};

function _templateObject$3() {
  var data = _taggedTemplateLiteral([""]);

  _templateObject$3 = function _templateObject() {
    return data;
  };

  return data;
}
var SVG$2 = styled(SVGIcon)(_templateObject$3());

var UserSVG = function UserSVG(_ref) {
  var _ref$darkMode = _ref.darkMode,
      darkMode = _ref$darkMode === void 0 ? false : _ref$darkMode;
  return /*#__PURE__*/React.createElement(SVG$2, {
    viewBox: "0 0 28 28",
    width: 28,
    height: 28
  }, /*#__PURE__*/React.createElement("path", {
    d: "M21.9561 23H6.03702C5.69572 23 5.43217 22.71 5.47473 22.3815L5.69449 20.7004C6.22444 16.6469 9.78147 13.6083 13.9965 13.6083C18.2116 13.6083 21.7686 16.6469 22.2986 20.7004L22.5184 22.3815C22.5613 22.71 22.2974 23 21.9561 23Z",
    fill: darkMode ? palette.base.white : palette.base.black
  }), /*#__PURE__*/React.createElement("path", {
    d: "M13.9967 12.6586C16.1784 12.6586 17.947 10.9441 17.947 8.82929C17.947 6.71443 16.1784 5 13.9967 5C11.815 5 10.0464 6.71443 10.0464 8.82929C10.0464 10.9441 11.815 12.6586 13.9967 12.6586Z",
    fill: darkMode ? palette.base.white : palette.base.black
  }));
};

function _templateObject14() {
  var data = _taggedTemplateLiteral(["\n  width: 28px;\n  height: 28px;\n"]);

  _templateObject14 = function _templateObject14() {
    return data;
  };

  return data;
}

function _templateObject13() {
  var data = _taggedTemplateLiteral(["\n  justify-content: space-between;\n"]);

  _templateObject13 = function _templateObject13() {
    return data;
  };

  return data;
}

function _templateObject12() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 52px;\n  background-color: ", ";\n"]);

  _templateObject12 = function _templateObject12() {
    return data;
  };

  return data;
}

function _templateObject11() {
  var data = _taggedTemplateLiteral(["\n  margin-left: 3px;\n  white-space: nowrap;\n"]);

  _templateObject11 = function _templateObject11() {
    return data;
  };

  return data;
}

function _templateObject10() {
  var data = _taggedTemplateLiteral(["\n  margin-left: 3px;\n\n  ", " {\n    width: 44px;\n    overflow: hidden;\n    white-space: nowrap;\n    text-overflow: ellipsis;\n  }\n"]);

  _templateObject10 = function _templateObject10() {
    return data;
  };

  return data;
}

function _templateObject9() {
  var data = _taggedTemplateLiteral(["\n  margin-right: 7px;\n  display: flex;\n  align-items: center;\n  cursor: pointer;\n  font-size: 14px;\n  line-height: 24px;\n  letter-spacing: -0.72px;\n  color: ", ";\n\n  position: relative;\n  padding: 7px;\n  transition: background-color 200ms cubic-bezier(0.65, 0, 0.35, 1);\n\n  &:hover {\n    border-radius: 2px;\n    background-color: ", ";\n  }\n\n  &:last-of-type {\n    margin-right: 0;\n  }\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  align-items: center;\n  min-width: 28px;\n  min-height: 28px;\n  margin-left: 29px;\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = _taggedTemplateLiteral(["\n  color: ", ";\n  font-size: 14px;\n  line-height: 24px;\n  letter-spacing: -0.72px;\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteral(["\n  flex: 1;\n  max-width: 573px;\n  min-width: 190px;\n  height: 20px;\n  border-radius: 2px;\n  padding: 9px;\n  cursor: pointer;\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n  outline: none;\n  background-color: ", ";\n  &:hover {\n    background-color: ", ";\n  }\n  ", "\n\n  transition: all 200ms;\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  width: 100%;\n  height: 100%;\n  justify-content: space-between;\n  align-items: center;\n  margin-left: 26px;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  white-space: nowrap;\n  font-weight: 700;\n  font-size: 18px;\n  line-height: 24px;\n  letter-spacing: -0.45px;\n  margin-left: ", "px;\n  color: ", ";\n  opacity: 0.2;\n  &:hover {\n    opacity: 0.4;\n  }\n\n  ", "\n\n  transition: opacity 200ms ease-in-out;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  align-items: center;\n  max-width: 1280px;\n  height: 100%;\n\n  padding: 0px 16px 0px 17.75px;\n  margin: 0 auto;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 60px;\n  background-color: ", ";\n  border-bottom: 1px solid ", ";\n  ", "\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$4() {
  var data = _taggedTemplateLiteral(["\n  ", "\n  width: 100%;\n  height: auto;\n\n  border: 1px solid rgba(24, 24, 24, 0.3);\n"]);

  _templateObject$4 = function _templateObject() {
    return data;
  };

  return data;
}
var Block = styled.header(_templateObject$4(), function (props) {
  return props.fixed && css(["position:fixed;top:0;left:0;"]);
});
var GNBBlock = styled.div(_templateObject2(), palette.base.white, palette.base.gray300, function (props) {
  return props.darkMode && css(["background-color:", ";border-bottom:none;"], palette.base.black);
});
var GNBInnerBlock = styled.div(_templateObject3());
var MainNavChip = styled.a(_templateObject4(), function (props) {
  return props.marginLeft || 26;
}, function (props) {
  return props.darkMode ? palette.base.white : palette.base.black;
}, function (props) {
  return props.isActive && css(["opacity:1;&:hover{opacity:1;}"]);
});
var ResponsiveBlock = styled.div(_templateObject5());
var SearchBar = styled.div(_templateObject6(), palette.base.gray100, palette.base.gray250, function (props) {
  return props.darkMode && css(["background-color:", ";&:hover{background-color:", ";}"], palette.base.gray900, palette.base.gray800);
});
var SearchBarPlaceholder = styled.span(_templateObject7(), function (props) {
  return props.darkMode ? palette.base.gray500 : palette.base.gray600;
});
var SubNavBlock = styled.div(_templateObject8());
var SubNav = styled.div(_templateObject9(), function (props) {
  return props.darkMode ? palette.base.white : palette.base.gray900;
}, function (props) {
  return props.darkMode ? palette.base.gray800 : palette.base.gray250;
});
var EllipsisText = styled.span(_templateObject10(), mediaQuery(800));
var OneLineText = styled.span(_templateObject11());
var TitleBlock = styled.div(_templateObject12(), palette.base.white);
var TitleInnerBlock = styled(GNBInnerBlock)(_templateObject13());
var EmptyBlock = styled.div(_templateObject14());

var GNB = function GNB(_ref) {
  var _ref$darkMode = _ref.darkMode,
      darkMode = _ref$darkMode === void 0 ? false : _ref$darkMode,
      _ref$fixed = _ref.fixed,
      fixed = _ref$fixed === void 0 ? true : _ref$fixed,
      _ref$showTitle = _ref.showTitle,
      showTitle = _ref$showTitle === void 0 ? true : _ref$showTitle,
      _ref$title = _ref.title,
      title = _ref$title === void 0 ? 'Please set page title' : _ref$title;

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      isMainActive = _useState2[0],
      setIsMainActive = _useState2[1];

  return /*#__PURE__*/React.createElement(Block, {
    fixed: fixed
  }, /*#__PURE__*/React.createElement(GNBBlock, {
    darkMode: darkMode
  }, /*#__PURE__*/React.createElement(GNBInnerBlock, null, /*#__PURE__*/React.createElement("div", null), /*#__PURE__*/React.createElement(MainNavChip, {
    isActive: isMainActive,
    href: "https://www.getcha.kr/",
    marginLeft: 23,
    darkMode: darkMode,
    onClick: function onClick() {
      return setIsMainActive(true);
    }
  }, "\uC2E4\uAC70\uB798\uAC00"), /*#__PURE__*/React.createElement(MainNavChip, {
    isActive: !isMainActive,
    href: "https://www.getcha.kr/community",
    darkMode: darkMode,
    onClick: function onClick() {
      return setIsMainActive(false);
    }
  }, "\uCEE4\uBBA4\uB2C8\uD2F0"), /*#__PURE__*/React.createElement(ResponsiveBlock, null, /*#__PURE__*/React.createElement(SearchBar, null, /*#__PURE__*/React.createElement(SearchBarPlaceholder, null, "\uC6D0\uD558\uB294 \uCC28 \uAC80\uC0C9\uD558\uAE30"), /*#__PURE__*/React.createElement(SearchSVG, null)), /*#__PURE__*/React.createElement(SubNavBlock, null, /*#__PURE__*/React.createElement(SubNav, {
    darkMode: darkMode
  }, /*#__PURE__*/React.createElement(UserSVG, {
    darkMode: darkMode
  }), /*#__PURE__*/React.createElement(EllipsisText, null, "\uB85C\uADF8\uC778")), /*#__PURE__*/React.createElement(SubNav, {
    darkMode: darkMode
  }, /*#__PURE__*/React.createElement(CabinetSVG, {
    darkMode: darkMode
  }), /*#__PURE__*/React.createElement(OneLineText, null, "\uACAC\uC801\uD568")))))), showTitle && /*#__PURE__*/React.createElement(TitleBlock, null, /*#__PURE__*/React.createElement(TitleInnerBlock, null, /*#__PURE__*/React.createElement(EmptyBlock, null), title, /*#__PURE__*/React.createElement(EmptyBlock, null))));
};

var Temp = (function () {
  return /*#__PURE__*/React.createElement(React.Fragment, null);
});

export { GNB, Temp };
