import React, { useState, useRef, useCallback } from 'react';
import styled from 'styled-components/native';
import arrayWithHoles from '@babel/runtime/helpers/esm/arrayWithHoles';
import iterableToArrayLimit from '@babel/runtime/helpers/esm/iterableToArrayLimit';
import unsupportedIterableToArray from '@babel/runtime/helpers/esm/unsupportedIterableToArray';
import nonIterableRest from '@babel/runtime/helpers/esm/nonIterableRest';
import { Dimensions, Animated, Easing } from 'react-native';
import LinearGradient from 'react-native-linear-gradient';

function _taggedTemplateLiteral(strings, raw) {
  if (!raw) {
    raw = strings.slice(0);
  }

  return Object.freeze(Object.defineProperties(strings, {
    raw: {
      value: Object.freeze(raw)
    }
  }));
}

var palette = {
  base: {
    white: '#ffffff',
    gray100: '#f7f7f7',
    gray150: '#f2f2f2',
    gray200: '#efefef',
    gray250: '#e8e8e8',
    gray300: '#e0e0e0',
    gray350: '#c7c7c7',
    gray400: '#aeaeae',
    gray500: '#959595',
    gray600: '#7c7c7c',
    gray700: '#646464',
    gray800: '#4a4a4a',
    gray900: '#232323',
    black: '#181818'
  },
  point: {
    red_getcha: '#ef3333',
    yellow_reward: '#ffd516',
    yellow_owner: '#e59f00',
    mint_realowner: '#29c5bb',
    blue_getcha: '#1d8ae4',
    green_getcha: '#38c52f'
  },
  yellow: {
    yellow_10: '#fcf5b3',
    yellow_20: '#fff385',
    yellow_30: '#ffe817',
    yellow_40_review: '#f0a22e'
  },
  mint: {
    mint_10: '#99e5d3',
    mint_20: '#0a8f61',
    mint_30: '#3aac87',
    mint_40: '#0a8f6'
  },
  blue: {
    blue_10: '#9cd6fa',
    blue_20: '#5db0ef',
    blue_30: '#1d8ae4',
    blue_40: '#265cd5'
  },
  red: {
    red_10: '#ffafaa',
    red_20: '#ff7970',
    red_30: '#e5403a',
    red_40: '#bc1b17'
  }
};

function _templateObject2() {
  var data = _taggedTemplateLiteral(["\n  font-weight: bold;\n  font-size: 16px;\n  line-height: 16px;\n  text-align: center;\n  letter-spacing: -0.5px;\n  color: ", ";\n"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  width: ", "px;\n  height: ", "px;\n  color: ", ";\n  background-color: ", ";\n  border-radius: 4px;\n"]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}
var GetchaButtonBlock = styled.TouchableOpacity(_templateObject(), function (props) {
  return props.width;
}, function (props) {
  return props.height;
}, function (props) {
  return props.color;
}, function (props) {
  return props.disabled ? palette.base.gray350 : props.backgroundColor;
});
var Text = styled.Text(_templateObject2(), palette.base.white);

var GetchaButton = function GetchaButton(_ref) {
  var _ref$width = _ref.width,
      width = _ref$width === void 0 ? 360 : _ref$width,
      _ref$height = _ref.height,
      height = _ref$height === void 0 ? 52 : _ref$height,
      _ref$text = _ref.text,
      text = _ref$text === void 0 ? 'Getcha' : _ref$text,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? palette.base.white : _ref$color,
      _ref$backgroundColor = _ref.backgroundColor,
      backgroundColor = _ref$backgroundColor === void 0 ? palette.point.red_getcha : _ref$backgroundColor,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$onPress = _ref.onPress,
      onPress = _ref$onPress === void 0 ? function () {} : _ref$onPress;
  return /*#__PURE__*/React.createElement(GetchaButtonBlock, {
    disabled: disabled,
    width: width,
    height: height,
    color: color,
    backgroundColor: backgroundColor,
    onPress: onPress
  }, /*#__PURE__*/React.createElement(Text, null, text));
};

function _slicedToArray(arr, i) {
  return arrayWithHoles(arr) || iterableToArrayLimit(arr, i) || unsupportedIterableToArray(arr, i) || nonIterableRest();
}

function _templateObject9() {
  var data = _taggedTemplateLiteral(["\n  color: ", ";\n  font-weight: bold;\n  font-size: 12px;\n  line-height: 12px;\n  text-align: center;\n  letter-spacing: -0.5px;\n"]);

  _templateObject9 = function _templateObject9() {
    return data;
  };

  return data;
}

function _templateObject8() {
  var data = _taggedTemplateLiteral(["\n  position: absolute;\n  justify-content: center;\n  align-items: center;\n  width: 100%;\n  height: 42px;\n  bottom: 0;\n  left: 0;\n  background-color: ", ";\n"]);

  _templateObject8 = function _templateObject8() {
    return data;
  };

  return data;
}

function _templateObject7() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 100%;\n  padding-left: 20px;\n  padding-bottom: 72px;\n"]);

  _templateObject7 = function _templateObject7() {
    return data;
  };

  return data;
}

function _templateObject6() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 24px;\n"]);

  _templateObject6 = function _templateObject6() {
    return data;
  };

  return data;
}

function _templateObject5() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 24px;\n"]);

  _templateObject5 = function _templateObject5() {
    return data;
  };

  return data;
}

function _templateObject4() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: auto;\n  position: relative;\n"]);

  _templateObject4 = function _templateObject4() {
    return data;
  };

  return data;
}

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 58px;\n  padding: 18px 20px;\n\n  font-weight: bold;\n  font-size: 16px;\n  line-height: 22px;\n  letter-spacing: -0.5px;\n"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2$1() {
  var data = _taggedTemplateLiteral(["\n  width: 288px;\n  height: auto;\n  min-height: 148px;\n  max-height: 492px;\n  border-radius: 4px;\n  background-color: ", ";\n  position: relative;\n  overflow: hidden;\n"]);

  _templateObject2$1 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject$1() {
  var data = _taggedTemplateLiteral(["\n  justify-content: center;\n  align-items: center;\n  width: ", ";\n  height: ", ";\n  top: 0;\n  left: 0;\n  z-index: 1001;\n  position: absolute;\n  background-color: rgba(0, 0, 0, 0.5);\n"]);

  _templateObject$1 = function _templateObject() {
    return data;
  };

  return data;
}
var ModalBackground = styled.View(_templateObject$1(), Dimensions.get('window').width, Dimensions.get('window').height);
var ModalBlock = styled.View(_templateObject2$1(), palette.base.white);
var ModalTitle = styled.Text(_templateObject3());
var ModalScrollBody = styled.ScrollView(_templateObject4());
var StyledGradientTop = styled(LinearGradient)(_templateObject5());
var StyledGradientBottom = styled(LinearGradient)(_templateObject6());
var ModalScrollBodyView = styled.View(_templateObject7());
var ModalButton = styled.TouchableOpacity(_templateObject8(), palette.point.red_getcha);
var ModalButtonText = styled.Text(_templateObject9(), palette.base.white);

var GetchaModal = function GetchaModal(_ref) {
  var _ref$showModal = _ref.showModal,
      showModal = _ref$showModal === void 0 ? false : _ref$showModal,
      _ref$modalTitle = _ref.modalTitle,
      modalTitle = _ref$modalTitle === void 0 ? '팝업 타이틀' : _ref$modalTitle,
      _ref$buttonTitle = _ref.buttonTitle,
      buttonTitle = _ref$buttonTitle === void 0 ? '버튼 타이틀' : _ref$buttonTitle,
      children = _ref.children,
      _ref$onPressButton = _ref.onPressButton,
      onPressButton = _ref$onPressButton === void 0 ? function () {} : _ref$onPressButton;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isMaxSize = _useState2[0],
      setIsMaxSize = _useState2[1];

  var gradientAnimated = useRef(new Animated.Value(0)).current;
  var onLayoutListener = useCallback(function (e) {
    setIsMaxSize(e.nativeEvent.layout.height >= 492);
  }, []);
  if (!showModal) return /*#__PURE__*/React.createElement(React.Fragment, null);
  return /*#__PURE__*/React.createElement(ModalBackground, null, /*#__PURE__*/React.createElement(ModalBlock, {
    onLayout: onLayoutListener
  }, /*#__PURE__*/React.createElement(ModalTitle, null, modalTitle), isMaxSize && /*#__PURE__*/React.createElement(Animated.View, {
    style: {
      width: '100%',
      position: 'absolute',
      height: 24,
      top: 57,
      left: 0,
      zIndex: 2001,
      opacity: gradientAnimated || 0
    }
  }, /*#__PURE__*/React.createElement(StyledGradientTop, {
    colors: ['#ffffff', 'rgba(255,255,255,0.0001)'],
    start: {
      x: 0,
      y: 0
    },
    end: {
      x: 0,
      y: 0.7
    }
  })), /*#__PURE__*/React.createElement(ModalScrollBody, {
    showsVerticalScrollIndicator: false,
    onScrollBeginDrag: function onScrollBeginDrag() {
      return Animated.timing(gradientAnimated, {
        toValue: 1,
        duration: 500,
        easing: Easing.linear,
        useNativeDriver: true
      }).start();
    },
    onScrollEndDrag: function onScrollEndDrag() {
      return Animated.timing(gradientAnimated, {
        toValue: 0,
        duration: 500,
        easing: Easing.linear,
        useNativeDriver: true
      }).start();
    },
    scrollEventThrottle: 16
  }, /*#__PURE__*/React.createElement(ModalScrollBodyView, null, children)), /*#__PURE__*/React.createElement(ModalButton, {
    onPress: onPressButton
  }, /*#__PURE__*/React.createElement(ModalButtonText, null, buttonTitle)), isMaxSize && /*#__PURE__*/React.createElement(Animated.View, {
    style: {
      width: '100%',
      position: 'absolute',
      height: 24,
      bottom: 42,
      left: 0,
      zIndex: 2001,
      opacity: gradientAnimated || 0
    }
  }, /*#__PURE__*/React.createElement(StyledGradientBottom, {
    colors: ['rgba(255,255,255,0.0001)', '#ffffff'],
    start: {
      x: 0,
      y: 0
    },
    end: {
      x: 0,
      y: 0.7
    }
  }))));
};

export { GetchaButton, GetchaModal };
